void hook(EVENT *);

char shift_key = 0;
char shell_running = 0;
char shell[8] = {'d','o','o','r','s',0,0,0};

void hook(EVENT *event)  	// Called regularly by the TIOS
{
  if (event->Type == CM_IDLE)	// The calc is just idle..
  {
    shift_key = event->StatusFlags & (calculator ? 0x4 : 0x2);
    return;
  }
  if ((event->Type == CM_KEYPRESS) && (event->extra.Key.Code == 0x10B)) // ON key pressed
  {
    if (shift_key && (!shell_running))
    {
      char command_line[17]; // 8 chars + 1 + 5 + 2 + 1
      SYM_ENTRY *doors_sym = cherche_lib(shell);
      char *doors_folder;
      if (!doors_sym)
      {
        error(MSG_HOOK_NOTFOUND);
        return;
      }
      if (!IsDoorsOSfile(doors_sym))
      {
        error(MSG_HOOK_INVALID);
        return;
      }
      doors_folder = folder_of_sym(doors_sym);

      SymCpy(command_line, doors_folder); // Prepares the command line
      strcpy(command_line+strlen(doors_folder), "\\doors()");

      // Runs the explorer
      shell_running = 1;
      OSDisableBreak();
      push_parse_text(command_line);
      NG_rationalESI(top_estack);
      OSEnableBreak();
      shell_running = 0;
    }
  }
}
